#ifndef _GLOBAL_PROTOTYPES_H_MODULE_
#define _GLOBAL_PROTOTYPES_H_MODULE_

#include "glbtypes.h"
#define Strcmp(x,y)	strcmp(x,y)
#define Strcpy(x,y)	strcpy(x,y)
#define Strncpy(x,y,z)	strncpy(x,y,z)
#define Strncmp(x,y,z)	strncmp(x,y,z)
#define Strlen(x)	strlen(x)
#define Strdup(x)	strdup(x)
#define Memset(x,y,z)	memset(x,y,x)
#define Free(x)		free(x)

/*	#endif*/



	#ifndef _USED_STD_LIB_FILES_
	#define _USED_STD_LIB_FILES_

	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>

	#ifdef __USE_CTYPE_H__
	#include <ctype.h>
	#endif

	#endif


/************************ String tools - strtools.c ***********************************/

extern char * get_nth_token(int n,char * str);

extern cmp_str str_cmp(char * s1,char * s2);

extern char * next_token1(char * str);

extern char * next_token(char * str);

extern char * get_variable_name(char *);

extern char * get_variable(char *);


extern int refresh_buffer(char * buffer,int howmuch,int bufsize);

extern int put_back_in_buffer(char * str,int bufsize);

extern char * create_new_buffer(char * bufptr,int bufsize);

extern int normalize_buffer(char * bufptr,int bufsize);

/********************* Operator def tools - opdtools.c *********************************/

extern long opdef_ins(defined_op op, defined_op oda);

extern inline_op inline_opdef_last(inline_op l);

extern int inline_op_list_count_part(inline_op from,inline_op to);

extern int inline_op_list_count(inline_op i_op);

extern void destroy_inline_op_list_part(inline_op from,inline_op to);

extern void destroy_inline_op_list(inline_op src);

extern inline_op copy_inline_op_list_part(inline_op from,inline_op to);

extern inline_op copy_inline_op_list(inline_op); 
/* copies entire inline defs list */

extern int opdef_count(defined_op d_op);

extern void print_opd(defined_op l);

extern defined_op opdef_last(defined_op l);

extern int get_opdef_def(char *,defined_op,listnode,listnode,struct vardecl_listoflist *,struct type_listoflist *);


extern void mk_opd(struct op_definition * res,char * form,listnode defn,int attr,int prec);

extern void install_opd(defined_op base,char * form,listnode defn,int attr,int prec);

extern void finstall_opd(defined_op base, char * form,listnode defn, char * fdef,int attr,int prec);

extern void linstall_opd(defined_op base, char * form,listnode defn, listnode fdef,int attr,int prec);

/* int install_iopd(inline_op base,char * form,char * defn,int attr,int prec); */



extern int op_recognize(char *,listnode,defined_op,listnode,listnode,int,listnode,struct type_listoflist *,struct vardecl_listoflist *);

extern int inline_op_recognize(char *,listnode,inline_op,defined_op,listnode,listnode opspec,listnode,listnode,struct vardecl_listoflist *,struct type_listoflist *,int,int);





extern int get_function(char *,listnode,defined_op,listnode,listnode opspec,int,struct type_listoflist *,struct vardecl_listoflist *);

extern int get_expression(char *,listnode,defined_op,listnode,listnode,int,struct type_listoflist *,struct vardecl_listoflist *);

extern listnode get_exp_lst_ins(listnode mainlist,listnode toappend,int usebrct);

extern listnode op_to_function(listnode);






extern struct typerec * mk_asm_output(listnode ,listnode ,struct vardecl_listoflist * ,struct type_listoflist *,listnode dst,listnode inl,defined_op ops,listnode opspec,listnode inl_lab,int fnlstflag);

extern char * get_local_label(char *, listnode, enum lnd_attr);

extern void print_asm_output(listnode, listnode,struct vardecl_listoflist *, struct type_listoflist *,listnode dst,listnode inl,defined_op ops,listnode opspec,listnode inl_lab);

extern void interpret_meta_code(listnode mcode,listnode labels,struct vardecl_listoflist * vars,struct type_listoflist * types,listnode dst,listnode inl,defined_op ops,listnode opspec,listnode inl_lab);

extern int exec_inline_func(struct fundef * fn,listnode args,listnode labels,struct vardecl_listoflist * vars,struct type_listoflist * types,listnode dst,listnode inl,defined_op ops,listnode opspec,listnode inl_lab);

extern int get_typeof_decl(char *,struct type_listoflist *,struct vardecl_listoflist *,defined_op,listnode,listnode opspec,struct typerec **);

extern int get_code_block(char * instr,listnode dst,listnode inl,defined_op ops,listnode opspec,listnode inl_lab,listnode labels,struct vardecl_listoflist * vars,struct type_listoflist * types,int mode);

extern int get_var_decl(char *,struct type_listoflist * tlist,struct vardecl_listoflist * vlist,listnode,defined_op,listnode,listnode opspec,listnode,int,int *);

extern struct typerec * get_new_type_declaration(char *,struct type_listoflist *,struct vardecl_listoflist *,listnode,defined_op,listnode,listnode opspec,listnode);

/***************************************************************************/

extern int type_cmp(struct typerec * t1,struct typerec * t2);

extern void * set_typerec(struct typerec *,int,char *,enum typekind,enum typemodf,enum tb_built_in,struct fundef_list *);

extern listnode convert_type(struct type_listoflist *,struct typerec *,struct typerec *,listnode);

extern struct typerec * mk_type_from_arr(char *,struct typerec *,struct type_listoflist *,int *);


extern struct typerec * mk_ref_type_from_type(struct typerec *,enum typemodf, struct type_listoflist *,int);

extern struct type_list * install_type(struct type_list * tl,int,char *,enum typekind,enum typemodf,enum tb_built_in,struct fundef_list *);

extern struct typerec * validate_function(listnode,/*listnode,*/struct vardecl_listoflist *,struct type_listoflist *,listnode,int);

extern void destroy_vardecl_list(struct vardecl_list * vlst);

extern int get_type_from_code(char *,listnode,struct type_listoflist *,struct vardecl_listoflist *,char *,listnode,defined_op,listnode,listnode,struct typerec **);

extern struct vardecl_list * global_find_var_decl(char *, struct vardecl_listoflist *,int);

extern struct vardecl_list * global_find_var_decl_skip(char * name, struct vardecl_listoflist * vars,struct var_decl * skip,int mode);

extern int get_subtype_from_code(char *,struct typerec *,listnode,struct type_listoflist *,struct vardecl_listoflist *,listnode,defined_op,listnode,listnode,char * *,struct typerec * *);

extern struct vardecl_list * insert_var_decl(struct vardecl_list *,char *,struct typerec *,void *,int);

extern struct typerec * lookup_class_func(listnode,struct typerec *,struct vardecl_listoflist *,struct type_listoflist *,listnode);

extern struct typerec * get_type_by_id(long type_id, struct type_listoflist * tll);

extern struct typerec * get_type_by_id_local(long type_id, struct type_list * tl);

extern struct typerec * get_type_by_name(char * name,enum typemodf tm, struct type_listoflist * tll);

extern struct typerec * get_type_by_name_local(char * name,enum typemodf tm, struct type_list * tll);

extern struct typerec * get_type_by_name_skip(long skip_id,char * name,enum typemodf tm, struct type_listoflist * tll);

extern struct type_listoflist * get_typedef_layer(struct typerec * tr,struct type_listoflist * tll);

extern struct vardecl_listoflist * get_vardecl_layer(struct var_decl * vd,struct vardecl_listoflist * vll);

extern struct typerec * lookup_structure_subtype(char * name,enum typemodf tm,struct typerec * type,struct type_listoflist * types);

extern int check_top_class(struct typerec * type,unsigned long top_cl_id);

extern struct typerec * eval_type_refr(struct typerec * type,struct vardecl_listoflist * vars,struct type_listoflist * types,listnode labels,int bind,listnode valids);

extern struct typerec * mk_subtype_by_type(struct typerec * type1,struct typerec * type2, struct type_listoflist * tll,int);

extern struct typerec * mk_subtype_by_name(struct typerec * type,char * name,enum typemodf tm, struct type_listoflist * tll);

extern struct typerec * apply_modifier(struct typerec * type,listnode modif,listnode * std_constr,struct type_listoflist *);

extern struct vardecl_list * copy_vardecl_list(struct vardecl_list * vlst);

extern struct vardecl_list * lookup_var_decl(char * name,struct vardecl_list * lst,int mode);

extern struct vardecl_list * lookup_var_decl_attr(enum var_attr attr,struct vardecl_list * lst);

/***************************************************************************/

extern listnode mk_set_lnd(listnode,void *,enum lnd_attr);

extern listnode lnd_cdre(listnode l);

extern listnode mk_listnode(listnode l);

extern listnode mk_set_lnd(listnode l,void * data,enum lnd_attr attr);

extern listnode mk_head_lnd(listnode lst,void * data,enum lnd_attr attr);

extern listnode rm_listnode(listnode l);

extern listnode rm_last_node(listnode l);

extern listnode rm_lnd_all(listnode l);

extern listnode lnd_iapnde(listnode l,char * s);

extern listnode lnd_sapnde(listnode l,char * s);

extern listnode lnd_asapnde(listnode l,char * s,enum lnd_attr attr);

extern listnode lnd_rapnde(listnode l1,listnode l2);

extern listnode lnd_capnde(listnode l1,listnode l2);

extern int lnd_count(listnode l);

extern listnode get_nth_lnd(listnode l, int n);

extern listnode lnd_reverse_r(listnode l);

extern listnode rm_cdr_next(listnode l);

extern listnode copylist(listnode l);

extern listnode lnd_find(listnode l,char * d1,enum lnd_attr a1,int skip);

extern listnode lnd_replace(listnode l,void * d1,enum lnd_attr a1,void * d2,enum lnd_attr a2,int saveold,int repeat);

extern listnode lnd_find_x(listnode l,listnode x,int *skip);

extern int lnd_replace_x(listnode l,listnode x,listnode y,int repeat);

extern int list_compare(listnode l1,listnode l2);

extern int spec_lnd_count(listnode l,enum lnd_attr attr);

extern void printlist(listnode l);

extern void printlist1(listnode l,int step);

extern int printlist2(listnode l,int step,int j);

void lnd_attr_subst(listnode l,enum lnd_attr a1,enum lnd_attr a2);

/***************************************************************************/

extern int get_fn_arg_decl(char *,struct type_listoflist *,struct vardecl_listoflist *,listnode labels,defined_op,listnode,listnode opspec,listnode,int);

extern int test_get_constr_destr(char *,struct typerec *,struct type_listoflist *,struct vardecl_listoflist *,listnode labels,defined_op,listnode,listnode opspec,listnode,struct fundef **);

extern int test_get_fn_decl(char *,struct type_listoflist *,struct vardecl_listoflist *,listnode labels,defined_op,listnode,listnode opspec,listnode,struct fundef **);

/***************************************************************************/

extern listnode inline_op_find_var(char * name,listnode lst);

extern listnode inline_op_find_prefix(char * pref,listnode lst);

extern listnode inline_op_subst_lvar(char * name,listnode lst, listnode l);

extern int get_inl_varinfo(char * name, struct inline_varinfo * lst);

/***************************************************************************/

#ifndef __USE_CTYPE_H__

extern int isalnum(char);

extern int isalpha(char);

#endif

extern int isidch(char);

extern int isnum(char);

extern int isalnumsp(char);

/***************************************************************************/

extern void * my_malloc(unsigned long);

/***************************************************************************/

#endif

